
import { call, put } from 'redux-saga/effects';
import QueryString from 'query-string'

import * as api from '../../../constants/api';
import * as request from '../../../utils/request'; 
import { {{ camelCase name }}SetLoading, {{ camelCase name }}Merge } from '../actions'

export default function* save(action) {
  const { params = {}, query = {}, onSuccess = () => { }, onError = () => { } } = action.payload;

  try { 
    yield put({{ camelCase name }}SetLoading(true))
    const queryString = QueryString.stringify(query, { skipNull: true })
    const url = `${api.url}?${queryString}`

    const { data } = yield call(request.put, url, params);
    
    yield put(
      {{ camelCase name }}Merge({
        item: data,
        isLoading: false,
        isUpdated: true,
      }),
    )
    yield call(onSuccess, data)
  } catch (err) {
    yield call(onError, err.message);
  } finally {
    yield put({{ camelCase name }}SetLoading(false))
  }
}
